var __extends = this.__extends || function (d, b) {
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
/// <reference path="../Definitions/jquery.d.ts"/>
/// <reference path="../Definitions/sp.ui.d.ts"/>
// http://www.typescriptlang.org/Playground/
var TypeChecking;
(function (TypeChecking) {
    function f1(x, y) {
        return x * y;
    }
    function f2(x, y) {
        return x * y;
    }
    f2(1, 2);
    //f2("xx", "yy");
    })(TypeChecking || (TypeChecking = {}));
var Interfaces;
(function (Interfaces) {
    var Cat = (function () {
        function Cat(name) {
            this.name = "";
            this.name = name;
            this.age = 3;
        }
        Cat.prototype.speak = function () {
            console.log("meow!");
        };
        Cat.prototype.claw = function () {
            console.log("claw attack!");
        };
        return Cat;
    })();
    Interfaces.Cat = Cat;    
    ;
    var Lion = (function (_super) {
        __extends(Lion, _super);
        function Lion() {
            _super.apply(this, arguments);

        }
        Lion.prototype.claw = function () {
            console.log("claw attack v2");
        };
        return Lion;
    })(Cat);
    Interfaces.Lion = Lion;    
    var c1 = new Cat("Garfield");
    // Cat is a Type - so this assignment is invalid.
    // var c2: Cat = { name: "Sylvester", speak: function () { }, claw: function () { } };
    // Interface however, are type-checked by "shape" of the object.  And this is perfectly fine.
    var c2 = {
        name: "Sylvester",
        speak: function () {
        },
        claw: function () {
        }
    };
    var l1 = new Lion("Simba");
    l1.claw();
})(Interfaces || (Interfaces = {}));
var demo;
(function (demo) {
    function ShowDialog() {
        // see Definitions
        var dialog = SP.UI.ModalDialog.showModalDialog({
            url: "/Pages/demo.aspx",
            title: "Demo Page"
        });
        setTimeout(function () {
            dialog.close(SP.UI.DialogResult.OK);
        }, 5000);
    }
    demo.ShowDialog = ShowDialog;
})(demo || (demo = {}));
//@ sourceMappingURL=demo.js.map
